/*	flashWrite.c

	Copyright 2008 Fred Cooke

	This file is part of the FreeEMS project.

	FreeEMS software is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeEMS software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with any FreeEMS software.  If not, see <http://www.gnu.org/licenses/>.

	We ask that if you make any changes to this file you send them upstream to us at admin@diyefi.org

	Thank you for choosing FreeEMS to run your engine! */

#define FLASHWRITE_C
#include "inc/freeEMS.h"
#include "inc/flashWrite.h"

void eraseBlock(){
	// TBC
	
/*	27.4.2.4 Sector Erase Command
	
	The sector erase operation will erase all addresses in a 1 Kbyte sector of Flash memory using an embedded
	algorithm.
	
	An example flow to execute the sector erase operation is shown in Figure 27-29. The sector erase
	command write sequence is as follows:
	
	1. Write to a Flash block address to start the command write sequence for the sector erase command.
	The Flash address written determines the sector to be erased while global address bits [9:0] and the
	data written are ignored. Multiple Flash sectors can be simultaneously erased by writing to the
	same relative address in each Flash block.
	
	2. Write the sector erase command, 0x40, to the FCMD register.
	
	3. Clear the CBEIF flag in the FSTAT register by writing a 1 to CBEIF to launch the sector erase
	command.
	
	If a Flash sector to be erased is in a protected area of the Flash block, the PVIOL flag in the FSTAT register
	will set and the sector erase command will not launch. Once the sector erase command has successfully
	launched, the CCIF flag in the FSTAT register will set after the sector erase operation has completed unless
	a new command write sequence has been buffered. */

}

void writeBlock(){
	// TBC

	//whilepoll CBEIF from FSTAT
	//int i;
	//for (i=0;i<length;i++){
		// poll CBEIF flag and burn a word when ready
		//while(!(FSTAT & CBEIF)){/* Wait for ever until able to burn then move on */}
		
	//	FADDR = ?;
		
	//	FDATA = ?;
	//}

	// when set >
	
	// 
	
/*	27.4.2.3 Program Command

	The program operation will program a previously erased word in the Flash memory using an embedded
	algorithm.
	
	An example flow to execute the program operation is shown in Figure 27-28. The program command write
	sequence is as follows:

	1. Write to a Flash block address to start the command write sequence for the program command. The
	data written will be programmed to the address written. Multiple Flash blocks can be
	simultaneously programmed by writing to the same relative address in each Flash block.
	
	2. Write the program command, 0x20, to the FCMD register.
	
	3. Clear the CBEIF flag in the FSTAT register by writing a 1 to CBEIF to launch the program
	command.
	
	If a word to be programmed is in a protected area of the Flash block, the PVIOL flag in the FSTAT register
	will set and the program command will not launch. Once the program command has successfully launched,
	the CCIF flag in the FSTAT register will set after the program operation has completed unless a new
	command write sequence has been buffered. By executing a new program command write sequence on
	sequential words after the CBEIF flag in the FSTAT register has been set, up to 55% faster programming
	time per word can be effectively achieved than by waiting for the CCIF flag to set after each program
	operation.*/

}
