/*	memory.x

	Copyright 2008 Fred Cooke

	This file is part of the FreeEMS project.

	FreeEMS software is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeEMS software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with any FreeEMS software.  If not, see <http://www.gnu.org/licenses/>.

	We ask that if you make any changes to this file you send them upstream to us at admin@diyefi.org

	Thank you for choosing FreeEMS to run your engine! */

/* A description of what some of this means can be found at the following URL	*/
/* http://www.gnu.org/software/m68hc11/m68hc11_binutils.html					*/
/* http://m68hc11.serveftp.org/wiki/index.php/FAQ:Link							*/

  MEMORY
  {
/*    page0	(rwx)	: ORIGIN = 0x0000, LENGTH = 0x0000	This has been removed from the linker script as it is not relevant to the later core */
/*    eeprom (rx)	: ORIGIN = 0x0800, LENGTH = 0x0800 	 2K of eeprom for now, 4K requires paging */
    data	(rw)	: ORIGIN = 0x1000, LENGTH = 0x3000 /*	12K of ram for now, 32K requires paging */
	text1	(rx)	: ORIGIN = 0x4000, LENGTH = 0x4000 /*	Unpaged 4K flash block before page window */
	text2	(rx)	: ORIGIN = 0x8000, LENGTH = 0x4000 /*	Unpaged 4K flash block IN the page window */
	text	(rx)	: ORIGIN = 0xC000, LENGTH = 0x3700 /*	Unpaged 4K flash block after page window minus serial monitor and vector space */
/* TODO change the above to meaningful blocks of data with names */
	
/*  This seems to be wrong for S12X : Paged addresses = (((Value of PPAGE) * 0x4000) + 0x10000) */
	/* Instead these "ORIGIN" addresses are taken from a full -e hcs12mem dump */
    ppageE0	(rx)	: ORIGIN = 0x380000, LENGTH = 0x4000 /* ?? : This is text2 (default page window contents with ppage = 0x00) but can't write it! */
    ppageE1	(rx)	: ORIGIN = 0x384000, LENGTH = 0x4000 /* Flash error */
    ppageE2	(rx)	: ORIGIN = 0x388000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageE3	(rx)	: ORIGIN = 0x38C000, LENGTH = 0x4000 /* Flash error */
    ppageE4	(rx)	: ORIGIN = 0x390000, LENGTH = 0x4000 /* Flash error */
    ppageE5	(rx)	: ORIGIN = 0x394000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageE6	(rx)	: ORIGIN = 0x398000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageE7	(rx)	: ORIGIN = 0x39C000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageE8	(rx)	: ORIGIN = 0x3A0000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageE9	(rx)	: ORIGIN = 0x3A4000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageEA	(rx)	: ORIGIN = 0x3A8000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageEB	(rx)	: ORIGIN = 0x3AC000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageEC	(rx)	: ORIGIN = 0x3B0000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageED	(rx)	: ORIGIN = 0x3B4000, LENGTH = 0x4000 /* Wrote, but didn't work as text1 */
    ppageEE	(rx)	: ORIGIN = 0x3B8000, LENGTH = 0x4000
    ppageEF	(rx)	: ORIGIN = 0x3BC000, LENGTH = 0x4000
    ppageF0	(rx)	: ORIGIN = 0x3C0000, LENGTH = 0x4000
    ppageF1	(rx)	: ORIGIN = 0x3C4000, LENGTH = 0x4000
    ppageF2	(rx)	: ORIGIN = 0x3C8000, LENGTH = 0x4000
    ppageF3	(rx)	: ORIGIN = 0x3CC000, LENGTH = 0x4000
    ppageF4	(rx)	: ORIGIN = 0x3D0000, LENGTH = 0x4000
    ppageF5	(rx)	: ORIGIN = 0x3D4000, LENGTH = 0x4000
    ppageF6	(rx)	: ORIGIN = 0x3D8000, LENGTH = 0x4000
    ppageF7	(rx)	: ORIGIN = 0x3DC000, LENGTH = 0x4000
    ppageF8	(rx)	: ORIGIN = 0x3E0000, LENGTH = 0x4000
    ppageF9	(rx)	: ORIGIN = 0x3E4000, LENGTH = 0x4000
    ppageFA	(rx)	: ORIGIN = 0x3E8000, LENGTH = 0x4000
    ppageFB	(rx)	: ORIGIN = 0x3EC000, LENGTH = 0x4000
    ppageFC	(rx)	: ORIGIN = 0x3F0000, LENGTH = 0x4000
    ppageFE	(rx)	: ORIGIN = 0x3F8000, LENGTH = 0x4000 /* is this text2??? */
/*  ppageFD	(rx)	: ORIGIN = 0x3F4000, LENGTH = 0x4000 Represents 0x4000 - 0x7FFF (text1 paged) */
/*  ppageFF	(rx)	: ORIGIN = 0x3FC000, LENGTH = 0x3700 Represents 0xC000 - 0xFFFF (text paged) */
/*  The previous two lines are included for clarity only. */
/*	Changes to this file should be reflected in memory.h and Makefile also */
  }

  PROVIDE (_stack = 0x4000-1); /* Start the stack immediately after ram */
/*  PROVIDE (_vectors_addr = 0xFF00); I thought this was... : Where the linker puts the interrupt vectors. ...However apparently not. */
/* This is at 0xFF00 instead of 0xF700 because the monitor code redirects it, see AN2548 */
/* (also, the vector table on the 9s12x variants is twice as big...) */

